﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using System.Data;
using Infragistics.Windows;
using System.Windows.Controls.Primitives;
using System.Windows.Threading;

namespace XamDataGrid_RichTextBoxEditors
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        CVPStyleSelector selector;

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            this.xamDataGrid1.DataValueChangedDirect += new EventHandler<Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs>(xamDataGrid1_DataValueChangedDirect);
            this.xamDataGrid1.CellUpdated += new EventHandler<Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs>(xamDataGrid1_CellUpdated);
            this.xamDataGrid1.DataSource = this.TestData(20, 20).DefaultView;
            
            SetUpStyleSelector();
            
        }

        void xamDataGrid1_CellUpdated(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {
            if (e.Cell.Field.Name == "Column_1")
            {
                UpdateStyle(CellValuePresenter.FromCell(e.Cell), e.Cell.Value);
            }
        }

        void UpdateStyle(CellValuePresenter cvp, object cellValue)
        {
            int value = 0;
            int.TryParse(cellValue.ToString(), out value);
            if (value > 10)
            {
                cvp.Style = selector.RedStyle;

            }
            else
                cvp.Style = selector.BlueStyle;
        }

        void xamDataGrid1_DataValueChangedDirect(object sender, Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs e)
        {
            if (e.Field.Name == "Column_1")
            {
                UpdateStyle(e.CellValuePresenter, e.CellValuePresenter.Value);
            }
        }
        void SetUpStyleSelector()
        {
            selector = new CVPStyleSelector();
            selector.BlueStyle = (Style)this.LayoutRoot.TryFindResource("BlueStyle");
            selector.RedStyle = (Style)this.LayoutRoot.TryFindResource("RedStyle");
            this.xamDataGrid1.FieldLayouts[0].Fields["Column_1"].Settings.CellValuePresenterStyleSelector = selector;
        }

        private DataTable TestData(int numCols, int numRows)
        {
            DataTable dtData = new DataTable("Table1");
            for (int i = 1; i <= numCols; i++)
            {
                if (i % 2 == 0)
                {
                    dtData.Columns.Add("Column_" + i.ToString(), typeof(string));
                }
                else
                {
                    dtData.Columns.Add("Column_" + i.ToString(), typeof(int));
                }

            }
            for (int i = 1; i <= numRows; i++)
            {
                DataRow dr = dtData.NewRow();
                for (int j = 0; j < numCols; j++)
                {

                    if (j % 2 == 0)
                    {
                        dr[j] = i;
                    }
                    else
                    {
                        dr[j] = "SomeText" + i.ToString();
                    }

                }
                dtData.Rows.Add(dr);
            }

            return dtData;
        }

        
    }
}
